using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Zadatak2512020br3
{
    
    class Program
    {

        static void Main(string[] args)
        {
            int broj_koli_duzi = Convert.ToInt32(Console.ReadLine());
            int brojtacaka = 0;
            int rezervni_br_duzi = broj_koli_duzi;
            if (broj_koli_duzi < 8)
            {
                if (broj_koli_duzi == 1) brojtacaka = 3;
                if (broj_koli_duzi == 2) brojtacaka = 6;
                if (broj_koli_duzi == 3) brojtacaka = 7;
                if (broj_koli_duzi == 4) brojtacaka = 7;
                if (broj_koli_duzi == 5) brojtacaka = 8;
                if (broj_koli_duzi == 6) brojtacaka = 9;
                if (broj_koli_duzi == 7) brojtacaka = 10;
            }
            if (broj_koli_duzi == 8)
            {
                brojtacaka = 9;
            }
            if (broj_koli_duzi > 8)
            {
                int broj_tacaka_iz_matrice = 9;
                broj_koli_duzi -= 8;
                int broj_potrebnih_horizontala = broj_koli_duzi / 6;
                if (broj_koli_duzi > 6)
                    broj_koli_duzi /= 6;
                if (broj_koli_duzi == 0) brojtacaka = broj_tacaka_iz_matrice + broj_potrebnih_horizontala * 3;
                if (broj_koli_duzi == 1 || broj_koli_duzi == 2) brojtacaka = broj_tacaka_iz_matrice + broj_potrebnih_horizontala * 3 + 1;
                if (broj_koli_duzi == 3 || broj_koli_duzi == 4) brojtacaka = broj_tacaka_iz_matrice + broj_potrebnih_horizontala * 3 + 2;
                if (broj_koli_duzi == 5) brojtacaka = broj_tacaka_iz_matrice + broj_potrebnih_horizontala * 3 + 2;
                if (broj_koli_duzi == 7) brojtacaka = broj_tacaka_iz_matrice + broj_potrebnih_horizontala * 3 + 4;
            }
            Console.WriteLine(brojtacaka);
            if (rezervni_br_duzi == 8)
            {
                for (int i = 0; i < 3; i++)
                {
                    for (int j = 0; j < 3; j++)
                    {
                        Console.WriteLine(i + " "+ j);
                    }
                }
            }
            if (rezervni_br_duzi == 1)
            {
                for(int i = 0; i < 3; i++)
                {
                    for(int j = 0; j <= 0; j++)
                    {
                        Console.WriteLine(i + " " + j);
                    }
                }
            }
            if (rezervni_br_duzi == 2)
            {
                for (int i = 0; i < 3; i++)
                {
                    for (int j = 0; j <= 1; j++)
                    {
                        Console.WriteLine(i + " " + j);
                    }
                }
            }
            if (rezervni_br_duzi == 3)
            {
                for (int i = 0; i < 3; i++)
                {
                    for (int j = 0; j <= 1; j++)
                    {
                        Console.WriteLine(i + " " + j);
                    }
                }
                Console.WriteLine(3 + " " + 0);
            }
            if (rezervni_br_duzi == 4)
            {
                for (int i = 0; i < 3; i++)
                {
                    for (int j = 0; j <= 1; j++)
                    {
                        Console.WriteLine(i + " " + j);
                    }
                }
                Console.WriteLine(0 + " " + 2);
            }
            if (rezervni_br_duzi == 5)
            {
                for (int i = 0; i < 3; i++)
                {
                    for (int j = 0; j <= 1; j++)
                    {
                        Console.WriteLine(i + " " + j);
                    }
                }
                Console.WriteLine(0 + " " + 2);
                Console.WriteLine(1 + " " + 2);
            }
            if (rezervni_br_duzi == 6)
            {
                for (int i = 0; i < 3; i++)
                {
                    for (int j = 0; j <= 1; j++)
                    {
                        Console.WriteLine(i + " " + j);
                    }
                }
                Console.WriteLine(0 + " " + 2);
                Console.WriteLine(1 + " " + 2);
                Console.WriteLine(0 + " " + 3);
            }
            if (rezervni_br_duzi == 7)
            {
                for (int i = 0; i < 3; i++)
                {
                    for (int j = 0; j <= 1; j++)
                    {
                        Console.WriteLine(i + " " + j);
                    }
                }
                Console.WriteLine(2 + " " + 0);
                Console.WriteLine(2 + " " + 1);
                Console.WriteLine(1 + " " + 3);
                Console.WriteLine(0 + " " + 3);
            }
            if (rezervni_br_duzi > 8)
            {
                for (int i = 0; i < 3; i++)
                {
                    for (int j = 0; j < 3; j++)
                    {
                        Console.WriteLine(i + " " + j);
                    }
                }
                rezervni_br_duzi -= 8;
                int brojac = 2;
                while (rezervni_br_duzi - 6 > 0)
                {
                    for (int i = 0;i<3;i++)
                    {
                        Console.WriteLine(brojac+1 + " " + i);
                    }
                    brojac++;
                    rezervni_br_duzi -= 6;
                }
                if (rezervni_br_duzi == 1)
                {
                    Console.WriteLine(brojac+1 + " " + 1);
                }
                if (rezervni_br_duzi == 2)
                {
                    Console.WriteLine(brojac + 1 + " " + 0);
                }
                if (rezervni_br_duzi == 3)
                {
                    Console.WriteLine(brojac + 1 + " " + 0);
                    Console.WriteLine(brojac + 1 + " " + 1);
                }
                if (rezervni_br_duzi == 4)
                {
                    Console.WriteLine(brojac + 1 + " " + 0);
                    Console.WriteLine(brojac + 1 + " " + 2);
                }
                if (rezervni_br_duzi == 5)
                {
                    Console.WriteLine(brojac + 1 + " " + 0);
                    Console.WriteLine(brojac + 2 + " " + 0);
                    Console.WriteLine(brojac + 1 + " " + 1);
                }
                if (rezervni_br_duzi == 7)
                {
                    Console.WriteLine((brojac + 1) + " " + 1);
                }
            }
            Console.ReadKey();
        }
    }
}